
;**************************************************************************
;*              AMS Display Driver 1 (SW) - Example / Demo                *
;**************************************************************************
;**************************************************************************
;*                                                                        *
;*          v 1.08 - 15.08.2015                                           *
;*                                                                        *
;**************************************************************************
;*          Hardw.: PIC16F1823 used                                       *
;**************************************************************************


 INCLUDE "P16F1823.INC"


_U001			     EQU     B'00100110000100'		;see Page 48 of Datasheet
_U002			     EQU     B'01100011111111'		;see Page 49 of Datasheet


	__CONFIG	_CONFIG1, _U001
	__CONFIG	_CONFIG2, _U002


;==========================================================================
;       Variable Definition
;==========================================================================
TIMER1		EQU	H'20'		;delay routine
TIMER2		EQU	H'21'		; "	"	"
TIMER3		EQU	H'22'		;delay routine

v_intensity	EQU	H'23'
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------


;==========================================================================

		ORG	0		;Reset vector address
		goto	start

;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


;	       **********************************
;              **  RESET :  main boot routine  **
;              **********************************

start		nop

		clrf	BSR
		movlw	H'FF'
		movwf	PORTC
;
		clrf	INTCON		;disable interrupts

		banksel	OPTION_REG	;BANK 1
		movlw	B'01111111'
		movwf	OPTION_REG	;see datasheet Page 176

		movlw	H'01'
		movwf	BSR		;select BANK 1
		movlw	B'11111111'
		movwf	TRISA

		movlw	B'11111111'
		movwf	TRISC

		movf	OSCCON,0
		andlw	B'11101111'
		iorlw	B'01101000'
		movwf	OSCCON		;set 4MHz internal clock (default after reset is 500kHz)

		movlw	H'04'
		movwf	BSR		;select BANK 4
		movlw	B'00111111'
		movwf	WPUA		;enable weak pull-ups
		clrf	WPUC		;disable weak pull-ups for PORTC
		bsf	WPUC,D'005'	;enable week pull-up for RC5 (input from battery monitor)
		bsf	WPUC,D'003'	;enable week pull-up for Setup switch
		bsf	WPUC,D'002'	;enable week pull-up for "charger-connected flag"

		banksel	LATC
		clrf	LATC

		clrf	BSR		;select BANK 0

		clrf	PORTA
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------

		call	AMS_init

;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
start_up	nop

		call	AMS_test
		call	dr2
		call	dr2
		call	dr2
		call	AMS_test_off

;--------------------------------------------------

main_loop	nop

		call	demo1
		call	demo2
		call	demo3

		goto	main_loop

;--------------------------------------------------------------------
;--------------------------------------------------------------------
demo1		movlw	' '
		movwf	ams_v_dig0
		movwf	ams_v_dig1
		movwf	ams_v_dig2
		movwf	ams_v_dig3
		movwf	ams_v_dig4
		movwf	ams_v_dig5
		movwf	ams_v_dig6
		movwf	ams_v_dig7

		movlw	'0'
		movwf	ams_v_dig0
		call	AMS_disp_code
		call	dr2

		movlw	'1'
		movwf	ams_v_dig1
		call	AMS_disp_code
		call	dr2

		movlw	'2'
		movwf	ams_v_dig2
		call	AMS_disp_code
		call	dr2

		movlw	'3'
		movwf	ams_v_dig3
		call	AMS_disp_code
		call	dr2

		movlw	'4'
		movwf	ams_v_dig4
		call	AMS_disp_code
		call	dr2

		movlw	'5'
		movwf	ams_v_dig5
		call	AMS_disp_code
		call	dr2

		movlw	'6'
		movwf	ams_v_dig6
		call	AMS_disp_code
		call	dr2

		movlw	'7'
		movwf	ams_v_dig7
		call	AMS_disp_code
		call	dr2
		call	dr2
		call	dr2

		movlw	'7'
		movwf	ams_v_dig0
		movlw	'6'
		movwf	ams_v_dig1
		movlw	'5'
		movwf	ams_v_dig2
		movlw	'4'
		movwf	ams_v_dig3
		movlw	'3'
		movwf	ams_v_dig4
		movlw	'2'
		movwf	ams_v_dig5
		movlw	'1'
		movwf	ams_v_dig6
		movlw	'0'
		movwf	ams_v_dig7
		call	AMS_disp_code
		call	dr2
		call	dr2
		call	dr2

		return


;--------------------------------------------------------------------
;--------------------------------------------------------------------
demo2		movlw	'0'
		movwf	ams_v_dig0
		movlw	'1'
		movwf	ams_v_dig1
		movlw	'2'
		movwf	ams_v_dig2
		movlw	'3'
		movwf	ams_v_dig3
		movlw	'4'
		movwf	ams_v_dig4
		movlw	'5'
		movwf	ams_v_dig5
		movlw	'6'
		movwf	ams_v_dig6
		movlw	'7'
		movwf	ams_v_dig7
		call	AMS_disp_code
		call	dr2

		movlw	H'00'
		movwf	v_intensity

demo2_loop	movf	v_intensity,0
		movwf	ams_v_dig0
		movwf	ams_v_dig1
		movwf	ams_v_dig2
		movwf	ams_v_dig3
		bcf	ams_v_dig0,D'004'
		bcf	ams_v_dig1,D'004'
		bcf	ams_v_dig2,D'004'
		bcf	ams_v_dig3,D'004'

		call	AMS_intensity
		call	AMS_disp_code

		call	dr2
		call	dr2

		incf	v_intensity,1
		btfss	v_intensity,D'004'
		goto	demo2_loop

		movlw	H'0F'
		call	AMS_intensity

		return
;--------------------------------------------------------------------
;--------------------------------------------------------------------
demo3		movlw	' '
		movwf	ams_v_dig0
		movwf	ams_v_dig1
		movwf	ams_v_dig2
		movwf	ams_v_dig3
		movwf	ams_v_dig4
		movwf	ams_v_dig5
		movwf	ams_v_dig6
		movwf	ams_v_dig7

		movlw	'0'
		movwf	ams_v_dig7
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig7
		movlw	'1'
		movwf	ams_v_dig6
		call	AMS_disp_code
		call	dr2
		
		movlw	' '
		movwf	ams_v_dig6
		movlw	'2'
		movwf	ams_v_dig5
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig5
		movlw	'3'
		movwf	ams_v_dig4
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig4
		movlw	'4'
		movwf	ams_v_dig3
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig3
		movlw	'5'
		movwf	ams_v_dig2
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig2
		movlw	'6'
		movwf	ams_v_dig1
		call	AMS_disp_code
		call	dr2

		movlw	' '
		movwf	ams_v_dig1
		movlw	'7'
		movwf	ams_v_dig0
		call	AMS_disp_code
		call	dr2

		return
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;--------------------------------------------------------------------
;--------------------------------------------------------------------

;		*********************************************
;		*               delay routine               *
;		*********************************************

;------------------------------------

d2		movlw	D'255'
		movwf	TIMER2
DEL_LOOP1	movlw	D'255'
		movwf	TIMER1

DEL_LOOP2	decfsz	TIMER1,F
		goto	DEL_LOOP2
		decfsz	TIMER2,F
		goto	DEL_LOOP1
		return
;------------------------------------
dr2		call	d2
		call	d2
		return
;------------------------------------
dr6		call	dr2
		call	dr2
		return
;-----------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------------

	INCLUDE "AMS_DDriver_SW_SPI_v1p09.inc"

		END